// pub(crate) mod lowlevel;
// mod nodes;
// pub mod vchannel;
pub mod peer;
pub mod msg;

// pub use nodes::Node;
// pub use nodes::Nodes;

pub mod channel_tags {
    pub struct SendPacketTag {}
    pub struct ReceivePacketTag {}
    pub struct MinorTickTag {}
    pub struct MajorTickTag {}
}

#[derive(PartialEq, PartialOrd, Clone)]
pub enum SendOrder {
    Route,
    Sign,
    Encrypt,
    Send,
}
pub type SendPacketChannel = (channel_tags::SendPacketTag, msg::Message, SendOrder);

#[derive(PartialEq, PartialOrd, Clone)]
pub enum ReceiveOrder {
    Decryption,
    Verify,
    Parse,
    Dispatch,
}
pub type ReceivePacketChannel = (channel_tags::ReceivePacketTag, msg::Message, ReceiveOrder);

/// Minor ticks (roughly once per second): for retries, status updates, etc.
pub type MinorTickChannel = (channel_tags::MinorTickTag, ());
/// Major ticks (several times per minute): for retries, cleanup tasks, periodic queries, etc
pub type MajorTickChannel = (channel_tags::MajorTickTag, ());
